# Proyecto_MecanismosdeAccion

A continuacin ser presentada una breve descripcin de los diferentes notebooks:

Para la ejecucin de cada uno de los notebooks, es importante descargar de manera previa el conjunto de datos en la siguiente URL: https://www.kaggle.com/c/lish-moa/data. Debido a su tamao, no fue posible dejarlo en una carpeta especfica dentro del repositorio. Este debe estar en un entorno local, donde vaya a ser guardado el repo.

Cada uno de los notebooks, contiene informacin de la forma de ejecucin.

## 1.) 01-Moa_AnalisisExploratorio**

En el anlisis exploratorio son descritas las variables, ingeniera de caracteristicas, distribuciones y conteo de protenas (mecanismos de accin) para el problema en desarollo.

## 2.) 02-PrimeraIteracion**

Para la primera iteracion, fueron tomadas dos protinas de las 206 totales. Una con mayor y otra con menor activacin respectivamente, y fueron probados de manera inicial tres diferentes tipo de modelos de machine learning para clasificacin: modelo de Bayes multinomial, regresin logstica y clasificador de vecinos cercanos. La ejecucin se debe realizar en orden, ejecutando celda a celda

## 3.) 1_ETAPA_ONEVsREST**

Para la ejecucin de la primera etapa, donde son probados cuatro modelos de clasificacin en un proceso OneVsrest, es importante considerar la ejecucin de manera ordenada para entender el problema:
* El archivo 03 consta de la primera experimentacin y mostrar los resultados del primer proceso de esta etapa. Es necesaria la instalacin de las libreras `scikit-multilearn` y `XGBoost` para su total ejecucin, esta se debe realizar celda a celda.
* El archivo 04 consta de un procedimiento similar al paso anterior, sin embargo, sern creados datos sintticos a travs del mtodo `SMOTE`. El mdulo que debe ser instalado para el uso de esta librera es `imblearn` y el notebook debe ser ejecutado celda a celda.
* El archivo 05 contiene la ejecucin de solo de los modelos de mquina de soporte y XGBoost usando GPU, la cual fue realizada a travs de la plataforma Kaggle. Es importante que se tenga una cuenta all o en su defecto que se tenga una mquina con GPU. Dentro de kaggle, en profile-->code podrn construir notebook y all debe ser activada la GPU. Para la ejecucin es importante la instalacin del mdulo de mquina de soporte encontrado en la siguiente URL `https://docs.rapids.ai/api/cuml/stable/`. La ejecucin debe ser realizada celda a celda.
* El archivo 06 contiene el procedimiento presentado anteriormente para los modelos de mquina de soporte y XGBoost, sin embargo, ser usado `SMOTE` como punto adicional. Su ejecucin se debe realizar, celda a celda.

## 4.) 2_ETAPA_MULTILABEL**

Para esta etapa fueron usando dos diferentes modelos para abordar el problema multietiqueta. Estos dos fueron: Random Forest y redes neuronales. Para el caso de las redes, fueron usados de dos diferentes libreras; scikit-learn y tensorflow.
* El archivo 07 contiene la ejecucin del modelo random forest y redes neuronales (usando la librera de scikit-learn). Es importante que sean instaladas las libreras mencionadas en los pasos anteriores y esta debe ser realizada celda a celda.
* El archivo 08 contiene la informacin para la ejecucin de redes neuronales usando las libreras de tensorflow, as que se hace necesaria la instalacin de este mdulo `pip install tensorflow`. La ejecucin se realizar celda a celda.

## 5.) 3_ETAPA_DEEPLEARNING**

Para la ltima etapa de la experimentacin, fueron usadas arquitecturas sofsticas a travs de redes neuronales con autoencoder y denoising autoenconders.
* El archivo 09 contiene la informacin para la ejecucin de las arquitecturas de redes neuronales usando denoising autoencoder (ruido blanco). Es importante la instalacin de mdulo de `tensorflow` y el complemento `tensorflow-addons`. La ejecucin debe ser realizda celda a celda.
* El archivo 10 contiene la informacin para le ejecucin de autoencoder pero usando los datos originales. Ya con la instalacin de los mdulos del paso anterior, solo debe ser ejecutado el notebook celda a celda.